using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Compression;

namespace File_Compressor
{
    public partial class Form1 : Form
    {
        OpenFileDialog opd = new OpenFileDialog();
        FolderBrowserDialog fbd = new FolderBrowserDialog();
        public Form1()
        {
            InitializeComponent();
           
        }

        private void button1_Click(object sender, EventArgs e)
        {
            opd.Filter = "Text File |*.txt";
            if (opd.ShowDialog() == DialogResult.OK)
            {
                textBox1.Text = opd.FileName;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (fbd.ShowDialog() == DialogResult.OK)
            {
                textBox2.Text = fbd.SelectedPath+"\\"+textBox3.Text+".txt";
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                if (textBox3.Text != "")
                {
                    Compress(opd.FileName);
                    button3.Enabled = false;
                    MessageBox.Show("File Compressed Successfully");
                }
                else
                {
                    MessageBox.Show("Enter Name of Text File to Save");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Select File To Compress");
            }
            finally
            {
            }
        }
        public void Compress(string filepath)
        {
                FileStream compress = new FileStream(fbd.SelectedPath + "\\" + textBox3.Text + ".txt", FileMode.Create, FileAccess.Write);
                FileStream decom = new FileStream(filepath, FileMode.Open, FileAccess.Read);
                StreamReader sr = new StreamReader(decom);
                string readDecom = sr.ReadToEnd();

                GZipStream zip = new GZipStream(compress, CompressionMode.Compress);

                StreamWriter sw = new StreamWriter(zip);

                sw.WriteLine(readDecom);
                sw.Flush();
                zip.Close();
                compress.Close();
            
        }
        public void DeCompress(string fileDeComp)
        {
            FileStream compfile = new FileStream(opd.FileName, FileMode.Open, FileAccess.Read);
            FileStream wrt_to_decomp = new FileStream(fbd.SelectedPath+"\\"+textBox4.Text+".txt",FileMode.Create,FileAccess.Write);
            GZipStream zip = new GZipStream(compfile, CompressionMode.Decompress);
            StreamReader read_comp = new StreamReader(zip);

            StreamWriter sw = new StreamWriter(wrt_to_decomp);
            sw.WriteLine(read_comp.ReadToEnd());
            textBox2.Text = read_comp.ReadToEnd();
            sw.Flush();
            compfile.Close();
            zip.Close();

        }
        private void button6_Click(object sender, EventArgs e)
        {
            try
            {
                if (textBox4.Text != "")
                {
                    DeCompress(opd.FileName);
                    button6.Enabled = false;
                    MessageBox.Show("File DeCompressed Successfully");
                }
                else
                {
                    MessageBox.Show("Enter Name of Text File to Save");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Select File To Compress");
            }
            finally
            {
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            opd.Filter = "Text File |*.txt";
            if (opd.ShowDialog() == DialogResult.OK)
            {
                textBox5.Text = opd.FileName;
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (fbd.ShowDialog() == DialogResult.OK)
            {
                textBox6.Text = fbd.SelectedPath + "\\" + textBox4.Text + ".txt";
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            help HELP = new help();
            HELP.ShowDialog();
       }

        private void button9_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Write to following E-Mail for any query or comment"+"\n"+"Contact : softwarenik@yahoo.in", "File Compressor");
        }
    }
}